<?php

if ($_SERVER["REQUEST_METHOD"] == "POST") {
	
	$apiurl = 'https://sandbox.esignlive.com';
	$apikey = 'your_api_key';
	$filepath = 'your_file_path';

	$headerArray = apache_request_headers();
	if (array_key_exists('Authorization', $headerArray)) {
		$callbackKey = $headerArray['Authorization'];
	}

	$data = file_get_contents('php://input');
	$payload = json_decode($data, true);
	$packageId = $payload['packageId'];
	$eventNmae = $payload['name'];

	error_log('Received an OneSpan Sign callback request: ' .$data. PHP_EOL, 3, "OSS Callback.log");

	// buffer all upcoming output
	ob_start();
	http_response_code(200);

	// get the size of the output
	$size = ob_get_length();

	// send headers to tell the browser to close the connection
	header("Content-Length:".$size);
	header('Connection: close');

	// flush all output
	ob_end_flush();
	ob_flush();
	flush();

	if ($eventNmae == 'PACKAGE_COMPLETE') {
		$curl = curl_init();

		curl_setopt_array($curl, array(
			CURLOPT_URL => $apiurl. "/api/packages/" . $packageId . "/documents/zip",
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => "",
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 30,
			CURLOPT_SSL_VERIFYHOST => false,
			CURLOPT_SSL_VERIFYPEER => false,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => "GET",
			CURLOPT_HTTPHEADER => array(
				"authorization: Basic ".$apikey,
			),
		));
		
		$response = curl_exec($curl);
		$httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		
		error_log('GET ' .$apiurl. "/api/packages/" . $packageId . "/documents/zip" . ' : '.$httpcode. PHP_EOL, 3, "OSS Callback.log");
		
		$err = curl_error($curl);

		curl_close($curl);

		if ($err) {
			error_log("cURL Error #:" . $err. PHP_EOL, 3, "OSS Callback.log");
		} else {
			file_put_contents($filepath."/documents_" . $packageId . "_" . date("Y_m_d_H_i_s") . ".zip", $response);
			error_log('Successfully downloaded file: '.$filepath."/documents_" . $packageId . "_" . date("Y_m_d_H_i_s") . ".zip". PHP_EOL, 3, "OSS Callback.log");
		}
	}
	
	
}
?>